Description

Currently, filtering issues by multiple tracker ids is possible with analyzing issues query filter.

e http://localhost:3000/issues ?f%5B%5D=tracker_id&op%5Btracker_id%5D=%3D&v%5Btracker_id%5D%5B%5D=1&v%5Btracke
r_id%5D%5B%5D=2&v%5Btracker id%5D%5B%5D=3

But building above URL path is not strait forward, and it's preferable to support like the following understandable parameter.

e http://localhost:3000/issues.json?tracker_id=1,2,3
¢ (On current trunk, this request returns 500 Internal Server Error)

Attached patch file enables above simple and understandable multiple tracker ids filter issues request.

Note that this patch was made by @rbt, Takashi Kato, @mbasa and me from Redmine patch meetup 14th.

History

#1 - 2022-05-27 16:06 - Ko Nagase
- File 0001-rest-api-filter-issues-by-multiple-tracker-ids.patch added

#2 - 2022-06-19 22:11 - Marius BALTEANU

- Target version set to Candidate for next major release

#3 - 2024-01-24 04:04 - Marius BALTEANU
- Status changed from New to Needs feedback

- Target version deleted (Candidate for next major release)

Indeed, the long syntax is not so user friendly, but you can use the short filters. For example, the same behaviour can be obtained using the following
query: issues.json?tracker_id=2|3 which will return all issues with tracker_id=2 or tracker_id=3. The delimiter operator is "|" and not ",".

Can you test and let me know if it works for you?

#4 - 2024-01-24 04:04 - Marius BALTEANU

This is available for all fields that support "is" operator, not only for tracker_id.

#5 - 2024-02-10 11:36 - Marius BALTEANU
- Tracker changed from Patch to Feature
- Status changed from Needs feedback to Closed

- Resolution set to Wont fix

Closing this.

Ko Nagase, please reopen if the current implementation does not cover your requirements.

#6 - 2024-02-13 14:29 - Ko Nagase
Marius BALTEANU wrote in #note-3:

Indeed, the long syntax is not so user friendly, but you can use the short filters. For example, the same behaviour can be obtained using the
http://localhost:3000/issues?f%5B%5D=tracker_id&op%5Btracker_id%5D=%3D&v%5Btracker_id%5D%5B%5D=1&v%5Btracker_id%5D%5B%5D=2&v%5Btracker_id%5D%5B%5D=3
http://localhost:3000/issues?f%5B%5D=tracker_id&op%5Btracker_id%5D=%3D&v%5Btracker_id%5D%5B%5D=1&v%5Btracker_id%5D%5B%5D=2&v%5Btracker_id%5D%5B%5D=3
http://localhost:3000/issues.json?tracker_id=1,2,3
https://www.redmine.org/users/486714
https://www.redmine.org/users/388654

following query: issues.json?tracker_id=2|3 which will return all issues with tracker_id=2 or tracker_id=3. The delimiter operator is "|" and not ",".
Can you test and let me know if it works for you?

Sorry for the late reply.

| confirmed that "|" works as expected.

Probably, the following add_short_filter seems to be the trick ?

https://www.redmine.org/projects/redmine/repository/svn/entry/trunk/app/models/query.rb#l 734

Anyway, thanks for the information!

#7 - 2024-02-13 22:50 - Marius BALTEANU

Ko Nagase wrote in #note-6:
Probably, the following add_short_filter seems to be the trick ?
https://www.redmine.org/projects/redmine/repository/svn/entry/trunk/app/models/query.rb#L. 734

Yes, that it is.

Files

0001-rest-api-filter-issues-by-multiple-tracker-ids.patch 2.77 KB 2022-05-27 Ko Nagase
